<script>
    import { goto } from '@sapper/app'
    import Header from 'components/Header.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import FormControl from 'components/Settings/FormControl.svelte'
    import Input from 'components/Settings/Input.svelte'
    import { patch } from 'lib/fetch'
    import validate from 'lib/validate'
    import { awaitingAPI, user } from 'store'

    let current_password = ''
    let password = ''
    let password_confirmation = ''
    let changed = false
    let inputs = {}
    let errors = {}

    const save = async () => {
        if (!(await validate(inputs))) return

        const { req, res } = await patch('/api/user/password', {
            current_password,
            password,
        })
        if (req.ok) {
            await goto('/@' + $user.username)
            return
        }
        errors.current_password = res?.errors?.current_password
    }
</script>

<Header withBackLink>Mettre le mot de passe à jour</Header>

<section>
    <div class="header">
        <button class="button" on:click={save} disabled={!changed}>
            {#if $awaitingAPI}
                <Spinner />
            {:else}OK{/if}
        </button>
    </div>
    <form>
        <FormControl
            name="current_password"
            label="Mot de passe actuel"
            errors={errors?.current_password}
        >
            <Input
                name="current_password"
                type="password"
                rules={['required', 'min:8']}
                bind:this={inputs.current_password}
                bind:value={current_password}
                on:input={() => {
                    changed = true
                    errors.current_password = undefined
                }}
                on:errors={event => (errors.current_password = event.detail)}
            />
        </FormControl>
        <div class="separator" />
        <FormControl
            name="password"
            label="Nouveau mot de passe"
            errors={errors?.password}
        >
            <Input
                name="password"
                type="password"
                bind:value={password}
                rules={['required', 'min:8']}
                bind:this={inputs.password}
                on:input={() => {
                    changed = true
                    errors.password = undefined
                }}
                on:errors={event => (errors.password = event.detail)}
            />
        </FormControl>
        <FormControl
            name="password_confirmation"
            label="Confirmer"
            errors={errors?.password_confirmation}
        >
            <Input
                name="password_confirmation"
                type="password"
                bind:value={password_confirmation}
                rules={[`confirmation:${password}`]}
                bind:this={inputs.password_confirmation}
                on:input={() => {
                    changed = true
                    errors.password_confirmation = undefined
                }}
                on:errors={event =>
                    (errors.password_confirmation = event.detail)}
            />
        </FormControl>
    </form>
</section>

<style lang="postcss">
    section {
        @apply py-4 bg-blueGray-50;

        .header {
            @apply px-4 mb-4 text-right;

            .button {
                @apply text-teal-50 bg-teal-500 rounded-full px-4 py-1;

                &:disabled {
                    @apply cursor-not-allowed bg-teal-200;
                }
            }
        }

        form {
            @apply grid grid-cols-2 gap-0 border-t border-b;
            grid-template-columns: max-content 1fr;

            .separator {
                @apply col-span-full py-2;
            }
        }
    }
</style>
